<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Mapping of OpenSCENARIO Actions &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Simulation" href="simulation.html" />
    <link rel="prev" title="EventDetector" href="event_detector.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Mapping of OpenSCENARIO Actions</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#acquirepositionaction">AcquirePositionAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#assignrouteaction">AssignRouteAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#customcommandaction">CustomCommandAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#followtrajectoryaction">FollowTrajectoryAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#lanechangeaction">LaneChangeAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#lightstateaction">LightStateAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#speedaction">SpeedAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#teleportaction">TeleportAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#trafficsignalaction">TrafficSignalAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#trafficsignalstateaction">TrafficSignalStateAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#trafficsinkaction">TrafficSinkAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#visibilityaction">VisibilityAction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#id1">LightStateAction</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">Mapping of OpenSCENARIO Actions</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/scenario_actions.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="mapping-of-openscenario-actions">
<span id="mapping-scenario-actions"></span><h1>Mapping of OpenSCENARIO Actions<a class="headerlink" href="#mapping-of-openscenario-actions" title="Link to this heading"></a></h1>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Layer/Component</p></th>
<th class="head"><p>API/Datatype</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenScenarioEngine</p></td>
<td><p>mantle_api</p></td>
</tr>
<tr class="row-odd"><td><p>opSimualtion</p></td>
<td><p>openPASS</p></td>
</tr>
<tr class="row-even"><td><p>FMU Interface</p></td>
<td><p>osi3</p></td>
</tr>
</tbody>
</table>
<section id="acquirepositionaction">
<h2>AcquirePositionAction<a class="headerlink" href="#acquirepositionaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>AcquirePositionAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>Entity::AssignRoute(UniqueId, RouteDefinition)
Entity::GetPosition()
GeometryHelper::TranslateGlobalPositionLocally()</p></td>
</tr>
<tr class="row-even"><td rowspan="2"><p>openPASS</p></td>
<td><p>SpawnParameter
AgentInterface::GetPositionX()
AgentInterface::GetPositionY()
AgentInterface::GetYaw()</p></td>
</tr>
<tr class="row-odd"><td><p>RouteSamplerInterface::CalculateRouteFromWaypoints(std::vector&lt;mantle_api::RouteWaypoint&gt;)
EgoAgentInterface::SetRoadGraph(RoadGraph, RoadGraphVertex, RoadGraphVertex)</p></td>
</tr>
<tr class="row-even"><td><p>osi3</p></td>
<td><p>x – not implemented</p></td>
</tr>
</tbody>
</table>
</section>
<section id="assignrouteaction">
<h2>AssignRouteAction<a class="headerlink" href="#assignrouteaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>AssignRouteAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>Entity::AssignRoute(UniqueId, RouteDefinition)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>RouteSamplerInterface::CalculateRouteFromWaypoints(std::vector&lt;mantle_api::RouteWaypoint&gt;)
EgoAgentInterface::SetRoadGraph(RoadGraph, RoadGraphVertex, RoadGraphVertex)</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>x – not relevant</p></td>
</tr>
</tbody>
</table>
</section>
<section id="customcommandaction">
<h2>CustomCommandAction<a class="headerlink" href="#customcommandaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>CustomCommandAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>ExecuteCustomCommand(actors, type, command)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>AddCustomCommand(command)
GetCustomCommands()
ComponentControllerImplementation::Trigger(time)
TrajectoryFollowerCommonBase::Trigger(time)</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>osi3::TrafficAction::CustomAction
TrafficAction::mutable_custom_action()
TrafficAction_CustomAction::set_command(command)</p></td>
</tr>
</tbody>
</table>
</section>
<section id="followtrajectoryaction">
<h2>FollowTrajectoryAction<a class="headerlink" href="#followtrajectoryaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>FollowTrajectoryAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>UpdateControlStrategies(FollowTrajectoryControlStrategy)
HasControlStrategyGoalBeenReached(ControlStrategyType::kFollowTrajectory)
GeometryHelper::TranslateGlobalPositionLocally(PolyLine)
MovementDomain::kBoth</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>SetStrategies(MovementDomain::kBoth, ControlStrategyType::kFollowTrajectory)
Algorithm_Routecontrol_Implementation::ReadWayPointData()
DynamicsScenarioImplementation::ReadWayPointData()
TrajectoryFollowerImplementation::Trigger(time)
FmuHelper::AddTrafficCommandActionFromOpenScenarioTrajectory(TrafficCommand::add_action(), Trajectory)</p></td>
</tr>
<tr class="row-odd"><td rowspan="2"><p>osi3</p></td>
<td><p><strong>osi3::TrafficAction::FollowTrajectoryAction</strong></p>
<p>TrafficAction::mutable_follow_trajectory_action()
TrafficAction_FollowTrajectoryAction::add_trajectory_point()</p>
</td>
</tr>
<tr class="row-even"><td><p><strong>osi3::TrafficAction::FollowPathAction</strong></p>
<p>TrafficAction::mutable_follow_path_action()
TrafficAction_FollowPathAction::add_path_point()</p>
</td>
</tr>
</tbody>
</table>
</section>
<section id="lanechangeaction">
<h2>LaneChangeAction<a class="headerlink" href="#lanechangeaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td rowspan="3"><p>OpenSCENARIO</p></td>
<td><p><strong>LaneChangeAction</strong></p>
<p>LaneChangeActionImpl::GetLaneChangeTarget()
ConvertScenarioLaneChangeTarget(ILaneChangeTarget) -&gt; mantle_api::LaneId</p>
</td>
</tr>
<tr class="row-odd"><td><p><strong>RelativeTargetLane</strong></p>
<p>LaneChangeTargetImpl::GetRelativeTargetLane()
ConvertScenarioRelativeTargetLane(IRelativeTargetLane) -&gt; mantle_api::LaneId</p>
</td>
</tr>
<tr class="row-even"><td><p><strong>AbsoluteTargetLane</strong></p>
<p>LaneChangeTargetImpl::GetAbsoluteTargetLane()
ConvertScenarioAbsoluteTargetLane(IAbsoluteTargetLane) -&gt; mantle_api::LaneId</p>
</td>
</tr>
<tr class="row-odd"><td rowspan="2"><p>mantle_api</p></td>
<td><p>UpdateControlStrategies(PerformLaneChangeControlStrategy)
(ControlStrategyType::kPerformLaneChange)</p></td>
</tr>
<tr class="row-even"><td><p><strong>Relative</strong></p>
<p>LaneLocationQueryService::GetRelativeLaneId()</p>
</td>
</tr>
<tr class="row-odd"><td><p>openPASS</p></td>
<td><p>SetStrategies(MovementDomain::kLateral, ControlStrategyType::kPerformLaneChange)
DynamicsScenarioImplementation::CalculateSinusiodalLaneChange(PerformLaneChangeControlStrategy)
DynamicsScenarioImplementation::ReadWayPointData()</p></td>
</tr>
<tr class="row-even"><td><p>osi3</p></td>
<td><p>x – not implemented</p></td>
</tr>
</tbody>
</table>
</section>
<section id="lightstateaction">
<h2>LightStateAction<a class="headerlink" href="#lightstateaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>LightStateAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>UpdateControlStrategies(FollowVelocitySplineControlStrategy)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>SetStrategies(std::vector&lt;std::shared_ptr&lt;mantle_api::ControlStrategy&gt;&gt;)</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>osi3::TrafficAction::CustomAction
CustomAction::command_type(“UpdateLightState &lt;LightType&gt;”)
CustomAction::command(“&lt;LightState&gt;”)</p></td>
</tr>
</tbody>
</table>
</section>
<section id="speedaction">
<h2>SpeedAction<a class="headerlink" href="#speedaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>SpeedAction</strong>
SetLinearVelocitySplineControlStrategy(std::string)</p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>UpdateControlStrategies(FollowVelocitySplineControlStrategy)
HasControlStrategyGoalBeenReached(ControlStrategyType::kFollowVelocitySpline)
SetSpeed(IEntity, units::velocity::meters_per_second_t)
MovementDomain::kLongitudinal</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>SetStrategies(MovementDomain::kLongitudinal, ControlStrategyType::kFollowVelocitySpline)
ControlStrategies::HasNewLongitudinalStrategy()
DynamicsScenarioImplementation::GetVelocityFromSplines()</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>osi3::TrafficAction::SpeedAction
TrafficAction::mutable_speed_action()
TrafficAction_CustomAction::set_absolute_target_speed(targetSpeed)</p></td>
</tr>
</tbody>
</table>
</section>
<section id="teleportaction">
<h2>TeleportAction<a class="headerlink" href="#teleportaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>TeleportAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>Entity::SetPosition(Vec3&lt;units::length::meter_t&gt;)
Entity::SetOrientation(Orientation3&lt;units::angle::radian_t&gt;)
Entity::SetAssignedLaneIds(std::vector&lt;uint64_t&gt;)
GeometryHelper::TranslateGlobalPositionLocally(…)
LaneLocationQueryService::GetUpwardsShiftedLanePosition(…)
LaneLocationQueryService::GetLaneIdsAtPosition(…)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>RouteSampler::Sample(mantle_api::Vec3&lt;units::length::meter_t&gt;, units::angle::radian_t)
AgentInterface::SetPositionX(units::length::meter_t)
AgentInterface::SetPositionY(units::length::meter_t)
AgentInterface:SetYaw(units::angle::radian_t)</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>x – not relevant</p></td>
</tr>
</tbody>
</table>
</section>
<section id="trafficsignalaction">
<h2>TrafficSignalAction<a class="headerlink" href="#trafficsignalaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>TrafficSignalAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>SetTrafficSignalState(std::string name, std::string state)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>WorldData::GetTrafficSignIdMapping()
WorldData::GetSignalType(Id)
WorldData::GetTrafficLight(Id)
ThreeSignalsTrafficLight::SetState(CommonTrafficLight::State)
TwoSignalsTrafficLight::SetState(CommonTrafficLight::State)
OneSignalsTrafficLight::SetState(CommonTrafficLight::State)
DataBuffer::PutAcyclic</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>TrafficLight_Classification::set_mode(::osi3::TrafficLight_Classification_Mode)</p></td>
</tr>
</tbody>
</table>
</section>
<section id="trafficsignalstateaction">
<h2>TrafficSignalStateAction<a class="headerlink" href="#trafficsignalstateaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>TrafficSignalStateAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>SetTrafficSignalState(std::string name, std::string state)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>WorldData::GetTrafficSignIdMapping()
WorldData::GetSignalType(Id)
WorldData::GetTrafficLight(Id)
ThreeSignalsTrafficLight::SetState(CommonTrafficLight::State)
TwoSignalsTrafficLight::SetState(CommonTrafficLight::State)
OneSignalsTrafficLight::SetState(CommonTrafficLight::State)
DataBuffer::PutAcyclic</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>TrafficLight_Classification::set_mode(::osi3::TrafficLight_Classification_Mode)</p></td>
</tr>
</tbody>
</table>
</section>
<section id="trafficsinkaction">
<h2>TrafficSinkAction<a class="headerlink" href="#trafficsinkaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>TrafficSinkAction</strong></p>
<p>ConvertScenarioTrafficDefinition(NET_ASAM_OPENSCENARIO::v1_1::ITrafficDefinition)</p>
</td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>Entity::GetPosition()
GeometryHelper::TranslateGlobalPositionLocally()</p></td>
</tr>
<tr class="row-even"><td rowspan="2"><p>openPASS</p></td>
<td><p>SpawnParameter</p></td>
</tr>
<tr class="row-odd"><td><p>AgentInterface::GetPositionX()
AgentInterface::GetPositionY()
AgentInterface:GetYaw()</p></td>
</tr>
<tr class="row-even"><td><p>osi3</p></td>
<td><p>x – not relevant</p></td>
</tr>
</tbody>
</table>
</section>
<section id="visibilityaction">
<h2>VisibilityAction<a class="headerlink" href="#visibilityaction" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>VisibilityAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>SetVisibility(EntityVisibilityConfig)</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>x – not implemented</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>x – not implemented</p></td>
</tr>
</tbody>
</table>
</section>
<section id="id1">
<h2>LightStateAction<a class="headerlink" href="#id1" title="Link to this heading"></a></h2>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>API/Datatype</p></th>
<th class="head"><p>Used Methods/Classes/API</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>OpenSCENARIO</p></td>
<td><p><strong>LightStateAction</strong></p></td>
</tr>
<tr class="row-odd"><td><p>mantle_api</p></td>
<td><p>UpdateControlStrategies(VehicleLightStatesControlStrategy)
MovementDomain::kNone</p></td>
</tr>
<tr class="row-even"><td><p>openPASS</p></td>
<td><p>Entity::SetVehicleLightState(mantle_api::LightState, mantle_api::LightType)</p></td>
</tr>
<tr class="row-odd"><td><p>osi3</p></td>
<td><p>osi3::TrafficAction_CustomAction</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Currently only indicatorLeft, indicatorRight and warningLights of OpenSCENARIO VehicleLightType are supported in openPASS.
OpenSCENARIO LightStateAction attribute, transitionTime is not received from the OSE</p>
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="event_detector.html" class="btn btn-neutral float-left" title="EventDetector" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="simulation.html" class="btn btn-neutral float-right" title="Simulation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>